.SUFFIXES: .o .elf
CFLAGS =  -c -mcpu=$(CPU) -MMD -g -omf=elf -O1 -msmart-io=1 -Wall -msfr-warn=off -MF
LFLAGS = -mcpu=$(CPU) -omf=elf -Wl,--defsym=__MPLAB_BUILD=1,,--script=p24EP64GP202.gld,--stack=16,--check-sections,--data-init,--pack-data,--handles,--isr,--no-gc-sections,--fill-upper=0,--stackguard=16,--library-path="..",--no-force-link,--smart-io,-Map="$O$(TARGET).map",--report-mem 

PK2DIR = c:\program files\microchip\pickit 2 v2
PK2OPTS = /H3 /I /J /P /R /M

# /////////////////////////////////////////////////////////////////////
#  Target "all"
#    1) *.o         ==> project.cof
#    2) project.cof ==> project.hex
# /////////////////////////////////////////////////////////////////////

all: "$O$(TARGET).elf"
	xc16-bin2hex "$O$(TARGET).elf" -a -omf=elf

"$O$(TARGET).elf": $(OBJS)
	xc16-gcc -o "$O$(TARGET).elf" $** $(LFLAGS)

# /////////////////////////////////////////////////////////////////////
#  Target "clean":
#    Deletes all intermediate files, but leaves output
# /////////////////////////////////////////////////////////////////////

clean:
	@echo Cleaning project
	@del "$O$(TARGET).elf" "$O$(TARGET).map" "$O$(TARGET).hex"
	@del "$O*.o"

# /////////////////////////////////////////////////////////////////////
#  Target "rebuild":
#    Cleans, then builds all
# /////////////////////////////////////////////////////////////////////

rebuild: clean all

# /////////////////////////////////////////////////////////////////////
#  Target "program":
#    Programs chip
# /////////////////////////////////////////////////////////////////////

program: all
  "$(PK2DIR)\PK2CMD" -b"$(PK2DIR)" /F"$O$(TARGET).hex" $(PK2OPTS)

# /////////////////////////////////////////////////////////////////////
#  Inference rules - how to build object files.
#   (Cannot chain inference rules - "from" file must already exist)
# /////////////////////////////////////////////////////////////////////

.c{$O}.o:
	xc16-gcc $< -o "$*.o" $(CFLAGS) "$*.o.d"

