.SUFFIXES: .s .o .cof
CFLAGS =  -mcpu=$(CPU) -x c -c -Wall -O1
SFLAGS = -mcpu=$(CPU) -c -Wa,-g
LFLAGS = -mcpu=$(CPU) -Wl,-Tp$(CPU).gld,--defsym=__MPLAB_BUILD=1,--Map="$O$(TARGET).map",--report-mem

PK2DIR = c:\program files\microchip\pickit 2 v2
PK2OPTS = /H3 /I /J /P /R /M

# /////////////////////////////////////////////////////////////////////
#  Target "all"
#    1) *.o         ==> project.cof
#    2) project.cof ==> project.hex
# /////////////////////////////////////////////////////////////////////

all: "$O$(TARGET).cof"
	pic30-bin2hex "$O$(TARGET).cof"

"$O$(TARGET).cof": $(OBJS)
	pic30-gcc $(LFLAGS) -o"$O$(TARGET).cof" $**

# /////////////////////////////////////////////////////////////////////
#  Target "clean":
#    Deletes all intermediate files, but leaves output
# /////////////////////////////////////////////////////////////////////

clean:
	@echo Cleaning project
	@del "$O$(TARGET).cof" "$O$(TARGET).map"
	@del $O*.o

# /////////////////////////////////////////////////////////////////////
#  Target "rebuild":
#    Cleans, then builds all
# /////////////////////////////////////////////////////////////////////

rebuild: clean all

# /////////////////////////////////////////////////////////////////////
#  Target "program":
#    Programs chip
# /////////////////////////////////////////////////////////////////////

program: all
  "$(PK2DIR)\PK2CMD" -b"$(PK2DIR)" /F"$O$(TARGET).hex" $(PK2OPTS)

# /////////////////////////////////////////////////////////////////////
#  Inference rules - how to build object files.
#   (Cannot chain inference rules - "from" file must already exist)
# /////////////////////////////////////////////////////////////////////

.c{$O}.o:
	pic30-gcc $(CFLAGS) -o$*.o -I"C:\Program Files (x86)\Microchip\AppLibrary\Microchip\Include" $<
	
.s{$O}.o:
	pic30-gcc $(SFLAGS) -o$*.o -I"C:\Program Files (x86)\Microchip\AppLibrary\Microchip\Include" $<
