/**********************************************************
 * MIDI Out Module for Yamaha Electone FX/FS Series organs
 * Tim Singer, 2012
 * Project page: http://tsstech.org/electronics/fxmidi.html
 * 
 * uart.h:  RS-232 communication
 **********************************************************/

//Configures the RS-232 UART (UART2)
void uart_init();

//Sends one byte.
void uart_send_byte(char byte);
//Sends the given number of bytes.
void uart_send_bytes(const char* bytes, uint16 count);
//Sends a null-terminated ASCII string (without the null terminator).
void uart_send_string(const char* bytes);   //Stops just before null terminator

//Formats and sends a 16-bit unsigned decimal integer.
void uart_print_int(uint16 i);
//Formats and sends a 16-bit unsigned hexadecimal integer.
void uart_print_hex(uint16 i);
//Formats and sends an 8-bit unsigned hexadecimal integer.
void uart_print_hex8(byte i);
